(function () {
    "use strict";

    angular.module('core').controller('reportFinanceiroCP000002Controller', controller);
    controller.$inject = ['$scope', '$q', '$stateParams', '$alert', 'faturaPagarService', 'lookupService', 'categoriaFinanceiraService'];

    function controller($scope, $q, $stateParams, $alert, faturaPagarService, lookupService, categoriaFinanceiraService) {
        $scope.initializeLayout('Títulos a Pagar');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            carregandoMais: false,
            salvando: false,
            vazio: false,
            count: 0,
            filtro: { ativo: false, args: null },
            totais: {
                ValorOriginal: null,
                ValorEmAberto: null,
                ValorLiquidado: null,
                ValorAbatido: null,
            },
        };
        $scope.auxiliar = {
            competencia: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllCompetencia({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            filial: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFilial({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            fornecedor: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFornecedor({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            categoriaFinanceira: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllCategoriaFinanceira({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
                data: [],
                selecionada: null,
                carregando: false,
                getAll: async () => {
                    $scope.auxiliar.categoriaFinanceira.carregando = true;
                    const args = { filtro: { IndicaAnalitica: false } };
                    try {
                        const response = await categoriaFinanceiraService.getAll(args);
                        if (response.Status < 0) {
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.auxiliar.categoriaFinanceira.data);
                            $scope.auxiliar.subcategoriaFinanceira.getAll();
                        }

                    } catch (error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(error);
                    } finally {
                        $scope.auxiliar.categoriaFinanceira.carregando = false;
                    }
                }
            },
            subcategoriaFinanceira: {
                lookup: function (chaves) {
                    var filtro = { CategoriaSuperior: { ID: null } };
                    if ($scope.popups.add.ativo && $scope.popups.add.data.Sugestao.Categoria) {
                        filtro.CategoriaSuperior.ID = $scope.popups.add.data.Sugestao.Categoria.ID;
                    }
                    if ($scope.popups.edit.ativo && $scope.popups.add.data.Categoria) {
                        filtro.CategoriaSuperior.ID = $scope.popups.edit.data.Categoria.ID;
                    }
                    return $q.when(
                        lookupService
                            .getAllSubcategoriaFinanceira({ chaves: chaves, filtro: filtro })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
                data: [],
                carregando: false,
                getAll: async () => {
                    if (!$scope.state.filtro.args.filtro?.Categoria)
                        return;

                    $scope.auxiliar.subcategoriaFinanceira.carregando = true;

                    const args = {
                        filtro: {
                            IndicaAnalitica: true,
                            Categoria: { ID: $scope.state.filtro.args.filtro.Categoria.ID }
                        }
                    };


                    try {
                        const response = await categoriaFinanceiraService.getAll(args);
                        if (response.Status < 0) {
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.auxiliar.subcategoriaFinanceira.data);
                            $scope.auxiliar.subcategoriaFinanceira.getAll();
                        }

                    } catch (error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(error);
                    } finally {
                        $scope.auxiliar.subcategoriaFinanceira.carregando = false;
                    }
                }
            },
            contaAnalitica: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllContaAnalitica({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            contaCorrente: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllContaCorrente({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            rateioCentroCusto: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllRateioCentroCusto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
        };

        //[Inicializa funcões]
        $scope.initialize = async () => {
            await $scope.clearFilter();

            const _filtro = $scope.localStorage.getItem('state.filtro.args');
            if (_filtro) {
                await angular.copy(_filtro, $scope.state.filtro.args);
            }

            if ($stateParams.id)
                $scope.popups.edit.toggle($stateParams.id);

            $scope.refresh();
        };

        $scope.beforeRefresh = async () => {
            await $scope.convertFilter();
        };
        $scope.afterRefresh = async () => {
            /* trata mudanças no filtro */
            $scope.state.filtro.original.sortExpression = $scope.state.filtro.args.sortExpression;
            $scope.state.filtro.original.skip = $scope.state.filtro.args.skip;
            $scope.state.filtro.original.take = $scope.state.filtro.args.take;

            $scope.state.filtro.hasChanges = (angular.toJson($scope.state.filtro.original) !== angular.toJson($scope.state.filtro.args));

            /* armazena na localstorage para quando inicializar a página */
            $scope.localStorage.setItem('state.filtro.args', $scope.state.filtro.args);
        };
        $scope.refresh = async () => {
            try {
                await $scope.beforeRefresh();
                $scope.state.filtro.ativo = false;
                await $scope.innerRefresh();
                await $scope.afterRefresh();
            }
            catch (error) {
                console.error(error);
                $scope.clearFilter();
            } finally {
                $scope.$digest();
            }
        };
        $scope.clear = async () => {
            await $scope.clearFilter();
            $scope.refresh();
        };

        $scope.toggleFilter = async () => {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };
        $scope.convertFilter = async () => {
            /* prepara o filtro. Ex: in list de status */
        };
        $scope.clearFilter = async () => {
            $scope.state.filtro = {
                args: {
                    chaves: '',
                    filtro: null,
                    filtroDe: {
                        Vencimento: $scope.tools.date.getNMesesAtras(6)
                    },
                    filtroAte: {
                        Vencimento: $scope.tools.date.hoje
                    },
                    sortExpression: '[Categoria.Nome], [Subcategoria.Nome], [VencimentoOriginal], [Codigo]',
                    skip: 0,
                    take: 1000
                },
                original: {},
                hasChanges: false
            };

            await $scope.convertFilter();
            await angular.copy($scope.state.filtro.args, $scope.state.filtro.original);
        };

        $scope.innerRefresh = async () => {
            await $scope.auxiliar.categoriaFinanceira.getAll();

            await $scope.getAll();
            await $scope.totalize();
        };
        $scope.getAll = async () => {
            try {
                $scope.state.filtro.args.skip = 0;
                $scope.state.carregando = true;
                $scope.state.vazio = false;

                let response = await faturaPagarService.getAllTituloPagar($scope.state.filtro.args)
                if (response.Status < 0) {
                    $scope.tools.toastr.error(response.Message, 'Serviço');
                } else {
                    angular.copy(angular.fromJson(response.Data), $scope.state.data);
                }
                $scope.state.vazio = ($scope.state.data == 0);
            }
            catch (error) {
                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
            }
            finally {
                $scope.state.carregando = false;
                $scope.$apply();
            }
        };
        $scope.totalize = async () => {
            try {
                let response = await faturaPagarService.totalizeTituloPagar($scope.state.filtro.args)
                if (response.Status < 0) {
                    $scope.tools.toastr.error(response.Message, 'Serviço');
                } else {
                    $scope.state.totais = response.Data;
                }
                $scope.state.vazio = ($scope.state.data == 0);
            } catch (error) {
                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
            } finally {
                $scope.$apply();
            }
        };

        /*Inicializa funções*/
        $scope.initialize();
    }

})();